
///////////////////////////////////////////////////////////
//	Noah.cpp:	Noah̃C̕łB
///////////////////////////////////////////////////////////

///////////////////// CN[h ////////////////////////

#include "stdafx.h"
#include "resource.h"
#include "FileList.h"
#include "util.h"

#include "ArcManEXE.h"
#include "ArcManDLL.h"
#include "ArcManMS2.h"
#include "ArcManACE.h"

///////////////////// O[oϐQ /////////////////////

struct NoahSetting
{
	CKString Type;		//k^Cv
	CKString COutput;	//ko͐tH_
	CKString MOutput;	//𓀏o͐tH_
	int Mode;			//
	bool MakeDir;		//ɖtH_邩H
	bool NoDouble;		//ȂAdtH_h~H
	bool OpenDir;		//𓀌AtH_JH
	bool ByExplorer;	//JȂAGNXv[ŁH
};

HINSTANCE g_hInst;
HWND g_hWnd;
NoahSetting g_Set;
CArcMan* g_pArcManTop = NULL;
bool g_bJapan;
bool g_bEndCode;
char szFailMelt[255],szFailCompress[255],szChooseDir[255],szSCFail[255],szSCOK[255];

//////////////////// ֐vg^Cv /////////////////////////

BOOL CALLBACK VersionDlg( HWND hDlg, UINT msg, WPARAM wPram, LPARAM lParam );
BOOL CALLBACK SettingDlg( HWND hDlg, UINT msg, WPARAM wPram, LPARAM lParam );
void DoINI( bool bRead );
bool Execute( CFileList& Files );
bool Dialogue( int showCmd );
bool Dlg2Set( HWND hDlg );
void InitArcManList();
void ReleaseArcManList();
void DefArcDLLLoad();

//////////////////// ֐̎ ////////////////////////////////

int APIENTRY WinMain( HINSTANCE hInst,HINSTANCE hPInst,char* pCmdLine,int nCmdShow )
{
	g_hInst = hInst;
	g_bJapan = (932==GetACP());

	GetAsyncKeyState(VK_SHIFT);// _~[iL[͗NAj

	LoadString( g_hInst, g_bJapan?IDS_CANNOTMELTJ:IDS_CANNOTMELT,         szFailMelt,255);
	LoadString( g_hInst, g_bJapan?IDS_CANNOTCOMPRESSJ:IDS_CANNOTCOMPRESS, szFailCompress,255);
	LoadString( g_hInst, g_bJapan?IDS_CHOOSEDIRJ:IDS_CHOOSEDIR,           szChooseDir,255);
	LoadString( g_hInst, g_bJapan?IDS_SCFAILJ:IDS_SCFAIL,                 szSCFail,255);
	LoadString( g_hInst, g_bJapan?IDS_SCOKJ:IDS_SCOK,                     szSCOK,255);

	DoINI( true );

	CFileList Files;
	Files.Create(pCmdLine);

	InitArcManList();

// C ////////////////////
	bool bShiftEnd = false;
	if( GetAsyncKeyState(VK_SHIFT)>>15 )// Shift  Set (1)
		goto dlgmode;
exemode:
	if( Execute(Files) )
		goto end;
dlgmode:
	if( bShiftEnd )
		goto end;
	if( Dialogue(nCmdShow) )
		DoINI( false );
	if( GetAsyncKeyState(VK_SHIFT)>>15 )// Shift  Set (2)
	{
		bShiftEnd = true;
		goto exemode;
	}
//////////////////////////////////
end:
	ReleaseArcManList();
	return 0;
}

// init@C̃[hZ[u
void DoINI( bool bRead )
{
	char InitFile[MAX_PATH];
	GetModuleFileName(NULL,InitFile,sizeof(InitFile));
	int len = strlen(InitFile);
	InitFile[len-3]='i',InitFile[len-2]='n',InitFile[len-1]='i';

	if( bRead )
	{
		char str[MAX_PATH];
		GetSpecialDir(str,CSIDL_DESKTOPDIRECTORY,NULL);
		CKString Desktop=str;	Desktop += "\\";

		GetPrivateProfileString( "Settings","Output",Desktop,str,sizeof(str),InitFile );
		CKString Output = str;
		//GetPrivateProfileString( "Settings","COutput",Desktop,str,sizeof(str),InitFile );
		GetPrivateProfileString( "Settings","COutput",Output,str,sizeof(str),InitFile );
		g_Set.COutput = str;
		//GetPrivateProfileString( "Settings","MOutput",Desktop,str,sizeof(str),InitFile );
		GetPrivateProfileString( "Settings","MOutput",Output,str,sizeof(str),InitFile );
		g_Set.MOutput = str;

		//g_Set.Mode = GetPrivateProfileInt( "Settings","JudgeMode",2,InitFile );
		int m = GetPrivateProfileInt( "Settings","DecisionMode",0,InitFile );
		switch( m ){
		case 1:	g_Set.Mode = GetPrivateProfileInt( "Settings","JudgeMode",2,InitFile );break;
		case 2:	g_Set.Mode = GetPrivateProfileInt( "Settings","JudgeMode",1,InitFile );break;
		case 3:	g_Set.Mode = GetPrivateProfileInt( "Settings","JudgeMode",4,InitFile );break;
		default:g_Set.Mode = GetPrivateProfileInt( "Settings","JudgeMode",3,InitFile );break;}

		g_Set.MakeDir = (0!=GetPrivateProfileInt( "Settings","MakeDir",1,InitFile ));
		g_Set.NoDouble = (0!=GetPrivateProfileInt( "Settings","NoDouble",0,InitFile ));
		g_Set.OpenDir = (0!=GetPrivateProfileInt( "Settings","OpenDir",1,InitFile ));
		g_Set.ByExplorer = (0!=GetPrivateProfileInt( "Settings","ByExplorer",0,InitFile ));
		GetPrivateProfileString( "Settings","CompressType","LH5(lzh)",str,sizeof(str),InitFile );
		g_Set.Type = str;
	}
	else
	{
		WritePrivateProfileInt(    "Settings","JudgeMode"   ,g_Set.Mode          ,InitFile );
		WritePrivateProfileInt(    "Settings","MakeDir"     ,g_Set.MakeDir?1:0   ,InitFile );
		WritePrivateProfileInt(    "Settings","NoDouble"    ,g_Set.NoDouble?1:0  ,InitFile );
		WritePrivateProfileInt(    "Settings","OpenDir"     ,g_Set.OpenDir?1:0   ,InitFile );
		WritePrivateProfileInt(    "Settings","ByExplorer"  ,g_Set.ByExplorer?1:0,InitFile );
		WritePrivateProfileString( "Settings","COutput"     ,g_Set.COutput       ,InitFile );
		WritePrivateProfileString( "Settings","MOutput"     ,g_Set.MOutput       ,InitFile );
		WritePrivateProfileString( "Settings","CompressType",g_Set.Type          ,InitFile );
	}
}

// G[ot@CO肵false
bool Execute( CFileList& Files )
{
	if( 0==Files.GetLength() )
		return false;

	// Ƃ肠k̂𓀂̂͂肳
	bool bMelt=false;

	// uɉ𓀁vAuSɂȂ𓀁vAuȂ爳kvłPt@CÂƂ͔
	if( g_Set.Mode==3 || (g_Set.Mode==2 && Files.GetLength()==1) || g_Set.Mode==4 )
	{
		for( int i=0; i!=Files.GetLength(); i++ )
		{
			bool bMeltable=false;
			Files.SetInfo( i,NULL );
			if( CArcMan::CanMeltCommon(Files.GetAt(i)) )
			{
				for( CArcMan *p=g_pArcManTop; p!=NULL; p=p->GetNext() )
				{
					if( p->CanMelt(Files.GetAt(i)) )
					{
						Files.SetInfo( i,(DWORD)p );
						bMeltable=true;
						break;
					}
				}
			}

			if( !bMeltable && g_Set.Mode!=4 )
			{
				bMelt=false;
				break;
			}
			if( bMeltable )
				bMelt=true;
		}
		if( !bMelt && g_Set.Mode==4 )
		{
			MessageBox(g_hWnd,szFailMelt,"Noah",MB_OK);
			return true;
		}
	}

	char pBuf[MAX_PATH];
	CKString Desktop;
	GetSpecialDir(pBuf,CSIDL_DESKTOPDIRECTORY,NULL);
	Desktop = pBuf;
	Desktop += "\\";

	if( bMelt )
	{
////////// 𓀁IIIIIIIIII ////////////////////////////
		for( int i=0; i!=Files.GetLength(); i++ )
		{
			CArcMan* p = (CArcMan*)Files.GetInfo(i);
			if( p==NULL )	continue;

			CKString MeltOut=g_Set.MOutput;
			if( p->Melt( Files.GetAt(i),&MeltOut,g_Set.MakeDir,g_Set.NoDouble ) )
			{
				if( g_Set.OpenDir && !MeltOut.Compare(Desktop) )
				{
//					"c:\output\" ƂtH_JƂ "c:\output.exe"
//					NĂ܂oOBWinExecł̃GNXv[ڋN
//					񂾂ǂȂ...GKgȂ񂾂...(^^;
//					ShellExecute( NULL,g_Set.ByExplorer?"explore":"open",MeltOut,NULL,NULL,SW_SHOWNORMAL );

					CKString Open = "explorer ";
					if( g_Set.ByExplorer )	Open += "/e,";
					Open += "\"";	Open += MeltOut;	Open += "\"";
					WinExec( Open,SW_SHOWNORMAL );
				}
			}
		}
	}
	else
	{
////////// kIIIIIIIIIIIII ////////////////////////////
		CArcMan* p = g_pArcManTop;
		while( p!=NULL )
		{
			if( p->CanCompress(g_Set.Type) )break;
			p=p->GetNext();
		}
		if( p==NULL )
		{
			MessageBox(g_hWnd,szFailCompress,"Noah",MB_OK);
			return false;
		}

		CreateDir( g_Set.COutput );

		bool bR;
		if( p->CanSFX() && GetAsyncKeyState(VK_CONTROL)>>15 )
			bR=p->SFX( g_Set.Type,Files,g_Set.COutput );
		else
			bR=p->Compress( g_Set.Type,Files,g_Set.COutput );

		if( bR && g_Set.OpenDir && !g_Set.COutput.Compare(Desktop) )
		{
//			ShellExecute( NULL,g_Set.ByExplorer?"explore":"open",g_Set.COutput,NULL,NULL,SW_SHOWNORMAL );
			CKString Open = "explorer ";
			if( g_Set.ByExplorer )	Open += "/e,";
			Open += "\"";	Open += g_Set.COutput;	Open += "\"";
			WinExec( Open,SW_SHOWNORMAL );
		}
	}

	return true;
}

// uۑIv(IDOK)Ȃtrue ȊOȂfalse
bool Dialogue( int showCmd )
{
	g_hWnd=CreateDialog( g_hInst,MAKEINTRESOURCE((g_bJapan?IDD_NOAH_DLGJ:IDD_NOAH_DLG)),NULL,SettingDlg );
	if( !g_hWnd )return false;
	ShowWindow( g_hWnd, showCmd );
	UpdateWindow( g_hWnd );

	MSG msg;
	HACCEL hAccel = LoadAccelerators( g_hInst, MAKEINTRESOURCE(IDC_NOAH) );
	while( GetMessage(&msg, NULL, 0, 0) ) 
	{
		if( !TranslateAccelerator( g_hWnd, hAccel, &msg ) ) 
		{
			if( !IsDialogMessage( g_hWnd,&msg ) )
			{
				TranslateMessage( &msg );
				DispatchMessage( &msg );
			}
		}
	}
	return g_bEndCode;
}

void InitArcManList()
{
	/*VArcManNX炱̊֐ƃt@Cincludê݂ύX邱*/

////// A[JCockk[h ///////////////////////////////
	CArcManDLL* p = NULL;
	bool bDLLLoaded = false;
	char s[MAX_PATH];
	GetSpecialDir(s,CSIDL_MODULE,NULL);
	CKString fname,typesdir = s;
	typesdir += "\\types\\";

	CKString nst[3] = {typesdir,typesdir,typesdir};
	nst[0] += "!*.nst";	nst[1] +=  "*.nst";	nst[2] += "$*.nst";

	WIN32_FIND_DATA Dt;
	HANDLE h;

	for( int i=0; i!=3; i++ )
	{
		h = FindFirstFile(nst[i],&Dt);
		if( h!=INVALID_HANDLE_VALUE )
		{
			do
			{
				if( i==1 && *Dt.cFileName=='!' || *Dt.cFileName=='$' )
					continue;
				fname = typesdir;
				fname += Dt.cFileName;
				p = new CArcManDLL;
				if( p->LoadFromNST(fname) )
				{
					bDLLLoaded=true;
					if( g_pArcManTop==NULL )	g_pArcManTop=p;
					else						g_pArcManTop->AddTail(p);
				}
				else
					delete p;
			}while( FindNextFile(h,&Dt) );
			FindClose(h);
		}
	}

	if( !bDLLLoaded )
		DefArcDLLLoad();

////// Unace ////////////////////////////////////////////////
	CArcManACE* ace = new CArcManACE;
	if( g_pArcManTop==NULL )	g_pArcManTop=ace;
	else						g_pArcManTop->AddTail(ace);

////// MS-Compress //////////////////////////////////////////
	CArcManMS2* ms = new CArcManMS2;
	if( g_pArcManTop==NULL )	g_pArcManTop=ms;
	else						g_pArcManTop->AddTail(ms);

////// EXE[h ///////////////////////////////
	CArcManEXE* exe = NULL;
	CKString nse = typesdir;
	nse += "*.nse";

	h = FindFirstFile(nse,&Dt);
	if( h!=INVALID_HANDLE_VALUE )
	{
		do
		{
			fname = typesdir;
			fname += Dt.cFileName;
			exe = new CArcManEXE;
			if( exe->LoadFromNSE(fname) )
			{
				if( g_pArcManTop==NULL )	g_pArcManTop=exe;
				else						g_pArcManTop->AddTail(exe);
			}
			else
				delete exe;
		}while( FindNextFile(h,&Dt) );
		FindClose(h);
	}
}

void DefArcDLLLoad()
{
	////// Unlha32.dll
	CArcManDLL* p = new CArcManDLL;
	p->Init("Unlha32.dll","UnlhaGetVersion","Unlha","UnlhaCheckArchive");
	p->AddCompressCmd("LH5(lzh)","lzh","a -x1 -r2 -a1 -jm2 -jso1 %s %s");
	p->AddCompressCmd("LH6(lzh)","lzh","a -x1 -r2 -a1 -jm3 -jso1 %s %s");
	p->AddCompressCmd("LH7(lzh)","lzh","a -x1 -r2 -a1 -jm4 -jso1 %s %s");
	p->SetSFXCmd("s -gw3 %s");
	p->SetMeltCmd("e -a1 -x1 -jyc %s");
	if( g_pArcManTop==NULL )	g_pArcManTop=p;
	else						g_pArcManTop->AddTail(p);
	////// UnZip32.dll
	p = new CArcManDLL;
	p->Init("UnZip32.dll","UnZipGetVersion","UnZip","UnZipCheckArchive");
	p->SetMeltCmd("-x %s");
	g_pArcManTop->AddTail(p);
	////// Zip32j.dll
	p = new CArcManDLL;
	p->Init("Zip32j.dll","ZipGetVersion","Zip","ZipCheckArchive");
	p->AddCompressCmd("ZIP_6(zip)","zip","-r -S %s %s");
	p->SetSFXCmd("--sfx %s");
	g_pArcManTop->AddTail(p);
	////// Cab32.dll
	p = new CArcManDLL;
	p->Init("Cab32.dll","CabGetVersion","Cab","CabCheckArchive");
	p->AddCompressCmd("MSZIP(cab)","cab","-a -r -mz %s %s");
	p->AddCompressCmd("LZX_21(cab)","cab","-a -r -ml:21 %s %s");
	p->SetSFXCmd("-f %s");
	p->SetMeltCmd("-x %s");
	g_pArcManTop->AddTail(p);
	////// Unrar32.dll
	p = new CArcManDLL;
	p->Init("Unrar32.dll","UnrarGetVersion","Unrar","UnrarCheckArchive");
	p->SetMeltCmd("-x %s");
	g_pArcManTop->AddTail(p);
	////// Unarj32j.dll
	p = new CArcManDLL;
	p->Init("Unarj32j.dll","UnarjGetVersion","Unarj","UnarjCheckArchive");
	p->SetMeltCmd("x -jyc -p %s");
	g_pArcManTop->AddTail(p);
	////// Tar32.dll
	p = new CArcManDLL;
	p->Init("Tar32.dll","TarGetVersion","Tar","TarCheckArchive");
	p->AddCompressCmd("GZIP_6(tgz)","tgz","cvfz %s %s");
	p->AddCompressCmd("BZIP2_9(bz2)","bz2","cvfzB %s %s");
	p->AddCompressCmd("SFX","exe","--self-extracting=1 cvfz %s %s");
	p->SetMeltCmd("xvf %s");
	g_pArcManTop->AddTail(p);
}

void ReleaseArcManList()
{
	CArcMan *p=g_pArcManTop , *p2;
	while( p!=NULL )
	{
		p2=p->GetNext();
		delete p;
		p=p2;
	}
}

BOOL CALLBACK SettingDlg( HWND hDlg, UINT msg, WPARAM wParam, LPARAM lParam )
{
	switch( msg )
	{
	case WM_INITDIALOG:
		DragAcceptFiles( hDlg, TRUE );
		{
			SetWindowLong( hDlg, GWL_STYLE, DS_FIXEDSYS|GetWindowLong(hDlg,GWL_STYLE) );
			SendMessage( hDlg, WM_SETICON, ICON_BIG, (LPARAM)LoadIcon(g_hInst,MAKEINTRESOURCE(IDI_NOAH)) );
			HMENU sysm = GetSystemMenu( hDlg,FALSE );
			DeleteMenu( sysm,SC_SIZE,MF_BYCOMMAND );
			DeleteMenu( sysm,SC_MAXIMIZE,MF_BYCOMMAND );
		}
		{
			CArcMan* p = g_pArcManTop;
			while( p!=NULL )
			{
				int n=p->GetTypeNum();
				for( int i=0; i!=n; i++ )
				{
					const char* c = p->GetType(i);
					if( *c=='$' || *c=='#' || *c=='&' || *c=='%' || *c=='*' )c++;
					if( 0==strcmp(c,"SFX") )continue;
//					SendDlgItemMessage(hDlg,IDC_CMPTYPE,CB_ADDSTRING,0,(LPARAM)(const char*)p->GetType(i));
					SendDlgItemMessage(hDlg,IDC_CMPTYPE,CB_ADDSTRING,0,(LPARAM)c);
				}
				p = p->GetNext();
			}
		}
		{
			SendDlgItemMessage(hDlg,IDC_JUDGE1,BM_SETCHECK,g_Set.Mode==1?BST_CHECKED:BST_UNCHECKED,0);
			SendDlgItemMessage(hDlg,IDC_JUDGE2,BM_SETCHECK,g_Set.Mode==2?BST_CHECKED:BST_UNCHECKED,0);
			SendDlgItemMessage(hDlg,IDC_JUDGE3,BM_SETCHECK,g_Set.Mode==3?BST_CHECKED:BST_UNCHECKED,0);
			SendDlgItemMessage(hDlg,IDC_JUDGE4,BM_SETCHECK,g_Set.Mode==4?BST_CHECKED:BST_UNCHECKED,0);

			SendDlgItemMessage(hDlg,IDC_MAKEFOL,BM_SETCHECK,g_Set.MakeDir?BST_CHECKED:BST_UNCHECKED,0);
			HWND nd = GetDlgItem(hDlg,IDC_NODOUBLE);
			if( g_Set.MakeDir )	SetWindowLong( nd,GWL_STYLE,(~WS_DISABLED)&GetWindowLong(nd,GWL_STYLE) );
			else				SetWindowLong( nd,GWL_STYLE,WS_DISABLED|GetWindowLong(nd,GWL_STYLE) );
			SendDlgItemMessage(hDlg,IDC_NODOUBLE,BM_SETCHECK,g_Set.NoDouble?BST_CHECKED:BST_UNCHECKED,0);

			SendDlgItemMessage(hDlg,IDC_OPENFOL,BM_SETCHECK,g_Set.OpenDir?BST_CHECKED:BST_UNCHECKED,0);
			HWND bx = GetDlgItem(hDlg,IDC_BYEX);
			if( g_Set.OpenDir )	SetWindowLong( bx,GWL_STYLE,(~WS_DISABLED)&GetWindowLong(bx,GWL_STYLE) );
			else				SetWindowLong( bx,GWL_STYLE,WS_DISABLED|GetWindowLong(bx,GWL_STYLE) );
			SendDlgItemMessage(hDlg,IDC_BYEX,BM_SETCHECK,g_Set.ByExplorer?BST_CHECKED:BST_UNCHECKED,0);

			SendDlgItemMessage(hDlg,IDC_COUTFOLDER,WM_SETTEXT,0,(LPARAM)((LPCSTR)g_Set.COutput));
			SendDlgItemMessage(hDlg,IDC_MOUTFOLDER,WM_SETTEXT,0,(LPARAM)((LPCSTR)g_Set.MOutput));

			SendDlgItemMessage(hDlg,IDC_CMPTYPE,CB_SELECTSTRING,-1,(LPARAM)((LPCSTR)g_Set.Type));
		}
		SetFocus((HWND)wParam);
		g_bEndCode = false;
		break;
	case WM_DESTROY:
		PostQuitMessage( 0 );
		break;
	case WM_DROPFILES:
		{
			SetForegroundWindow(hDlg);
			CFileList Drops;
			Drops.Create( (HDROP)wParam );
			DragFinish( (HDROP)wParam );

			Dlg2Set(hDlg);
			Execute(Drops);
		}
		break;
	case WM_SYSCOMMAND:
		switch( wParam )
		{
		case SC_CLOSE:
		case SC_DEFAULT:
			SendMessage(hDlg,WM_COMMAND,IDCANCEL,0);
			break;
		default:
			return FALSE;
		}
		break;
	case WM_COMMAND:
		switch( LOWORD(wParam) )
		{
////////// ANZ[^gbv /////////////////////////////////////////////////
		case IDA_MINIMIZE:	ShowWindow(hDlg,SW_MINIMIZE);	break;
		case IDA_FOLDER:
		case IDA_HELP:
			{
				char fol[MAX_PATH];
				GetSpecialDir( fol,CSIDL_MODULE,NULL );
				if( LOWORD(wParam)==IDA_HELP )	strcat( fol,"\\ReadMe.htm" );
				ShellExecute( NULL,"open",fol,NULL,NULL,SW_SHOWDEFAULT );
			}
			break;
////////// _CAÕ{^ ///////////////////////////////////////////////////////
		case IDC_MAKEFOL:
			{
				HWND nd = GetDlgItem(hDlg,IDC_NODOUBLE);
				if( BST_CHECKED==SendDlgItemMessage(hDlg,IDC_MAKEFOL,BM_GETCHECK,0,0) )
						SetWindowLong( nd,GWL_STYLE,(~WS_DISABLED)&GetWindowLong(nd,GWL_STYLE) );
				else	SetWindowLong( nd,GWL_STYLE,WS_DISABLED|GetWindowLong(nd,GWL_STYLE) );
				InvalidateRect(nd,NULL,TRUE);
			}
			break;
		case IDC_OPENFOL:
			{
				HWND bx = GetDlgItem(hDlg,IDC_BYEX);
				if( BST_CHECKED==SendDlgItemMessage(hDlg,IDC_OPENFOL,BM_GETCHECK,0,0) )
						SetWindowLong( bx,GWL_STYLE,(~WS_DISABLED)&GetWindowLong(bx,GWL_STYLE) );
				else	SetWindowLong( bx,GWL_STYLE,WS_DISABLED|GetWindowLong(bx,GWL_STYLE) );
				InvalidateRect(bx,NULL,TRUE);
			}
			break;
		case IDC_SENDSC:
			{
				char dstpath[MAX_PATH], myexe[MAX_PATH];
				if( !GetSpecialDir(dstpath,CSIDL_SENDTO,hDlg) )
					MessageBox(hDlg,szSCFail,"Noah",MB_OK|MB_ICONEXCLAMATION);
				else
				{
					GetModuleFileName(NULL, myexe, MAX_PATH);
					if( CreateLink(myexe, dstpath, "Noah") )
						MessageBox(hDlg,szSCOK,"Noah",MB_OK|MB_ICONINFORMATION);
					else
						MessageBox(hDlg,szSCFail,"Noah",MB_OK|MB_ICONEXCLAMATION);
				}
			}
			break;
		case IDC_VERSION:
			DialogBox(g_hInst,MAKEINTRESOURCE(IDD_VERSION),hDlg,VersionDlg);
			break;
		case IDC_CREF:
		case IDC_MREF:
			{
				UINT ctrl = (LOWORD(wParam)==IDC_CREF)?IDC_COUTFOLDER:IDC_MOUTFOLDER;
				char str[MAX_PATH],def[MAX_PATH];
				SendDlgItemMessage(hDlg,ctrl,WM_GETTEXT,MAX_PATH,(LPARAM)def);
				if( OpenFolderDlg(str,hDlg,szChooseDir,def) )
					SendDlgItemMessage(hDlg,ctrl,WM_SETTEXT,0,(LPARAM)str);
			}
			break;
////////// _CAOñ{^ //////////////////////////////////////////////
		case IDOK:
			g_bEndCode=true;
		case IDCANCEL:
			Dlg2Set(hDlg);
			DestroyWindow(hDlg);
			break;
		default:
			return FALSE;
		}
		break;
	default:
		return FALSE;
	}
    return TRUE;
}

bool Dlg2Set( HWND hDlg )
{
	char str[MAX_PATH];

	if( BST_CHECKED==SendDlgItemMessage(hDlg,IDC_JUDGE1,BM_GETCHECK,0,0) )		g_Set.Mode=1;
	else if( BST_CHECKED==SendDlgItemMessage(hDlg,IDC_JUDGE2,BM_GETCHECK,0,0) )	g_Set.Mode=2;
	else if( BST_CHECKED==SendDlgItemMessage(hDlg,IDC_JUDGE3,BM_GETCHECK,0,0) )	g_Set.Mode=3;
	else if( BST_CHECKED==SendDlgItemMessage(hDlg,IDC_JUDGE4,BM_GETCHECK,0,0) )	g_Set.Mode=4;

	g_Set.MakeDir = (BST_CHECKED==SendDlgItemMessage(hDlg,IDC_MAKEFOL,BM_GETCHECK,0,0));
	g_Set.NoDouble = (BST_CHECKED==SendDlgItemMessage(hDlg,IDC_NODOUBLE,BM_GETCHECK,0,0));

	g_Set.OpenDir = (BST_CHECKED==SendDlgItemMessage(hDlg,IDC_OPENFOL,BM_GETCHECK,0,0));
	g_Set.ByExplorer = (BST_CHECKED==SendDlgItemMessage(hDlg,IDC_BYEX,BM_GETCHECK,0,0));

	SendDlgItemMessage(hDlg,IDC_COUTFOLDER,WM_GETTEXT,MAX_PATH,(LPARAM)str);
	g_Set.COutput=str;
	SendDlgItemMessage(hDlg,IDC_MOUTFOLDER,WM_GETTEXT,MAX_PATH,(LPARAM)str);
	g_Set.MOutput=str;

	int i=SendDlgItemMessage(hDlg,IDC_CMPTYPE,CB_GETCURSEL,0,0);
	SendDlgItemMessage(hDlg,IDC_CMPTYPE,CB_GETLBTEXT,i,(LPARAM)str);
	g_Set.Type=str;

	return true;
}

BOOL CALLBACK VersionDlg( HWND hDlg, UINT msg, WPARAM wParam, LPARAM lParam )
{
	if( msg==WM_INITDIALOG )
	{
		CenterWindow(hDlg,g_hWnd);

		CKString str,tmp;
		CArcMan* p = g_pArcManTop;
		while( p!=NULL )
		{
			p->VersionString(tmp);
			str+=tmp;
			str+="\r\n";
			p=p->GetNext();
		}
		SendDlgItemMessage( hDlg,IDC_LIST,WM_SETTEXT,0,(LPARAM)(const char*)str );
		SendDlgItemMessage( hDlg,IDC_LIST,WM_SETFONT,(WPARAM)GetStockObject(ANSI_FIXED_FONT),MAKELPARAM(TRUE,0) );
		return TRUE;
	}
	else if( msg==WM_COMMAND && (LOWORD(wParam)==IDOK || LOWORD(wParam)==IDCANCEL) )
	{
		EndDialog(hDlg,IDOK);
		return TRUE;
	}
	return FALSE;
}
